#!/bin/sh
# Copyright (c) 2015 Oracle and/or its affiliates. All Rights Reserved.
# Copyright (c) International Business Machines Corp., 2005
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it would be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see .
#
# Author: Mitsuru Chinen
TST_TOTAL=2
TCID=if-addr-adddel
. if-lib.sh
TST_CLEANUP="do_cleanup"
# The interval of the check interface activity
CHECK_INTERVAL=${CHECK_INTERVAL:-$(($NS_TIMES / 20))}
do_cleanup()
{
cleanup
restore_ipaddr
}
test_body()
{
local cmd_type=$1
case $cmd_type in
if_cmd) local cmd_name='ifconfig' ;;
ip_cmd) local cmd_name='ip' ;;
*) tst_brkm TBROK "Unknown test parameter '$cmd_type'"
esac
local num=$(($(od -A n -t u1 -N 1 /dev/random) * 253 / 255 + 2 ))
local iface=$(tst_iface)
if [ "$TST_IPV6" ]; then
local new_ip=${IPV6_NET32_UNUSED}::$num
local netmask=64
else
local new_ip=${IPV4_NET16_UNUSED}.1.$num
local netmask=24
fi
tst_resm TINFO "'$cmd_name' add/del IPv$ipver '$new_ip' $NS_TIMES times"
if ! restore_ipaddr; then
tst_resm TBROK "Failed to set default IP addresses"
return
fi
make_background_tcp_traffic
local cnt=1
while [ $cnt -le $NS_TIMES ]; do
case $cmd_type in
if_cmd)
if [ "$TST_IPV6" ]; then
ifconfig $iface add $new_ip/$netmask
else
ifconfig $iface:1 $new_ip netmask 255.255.255.0
fi
;;
ip_cmd) ip addr add $new_ip/$netmask dev $iface ;;
esac
if [ $? -ne 0 ]; then
tst_resm TFAIL "command failed to add $new_ip to $iface"
return
fi
ip addr show $iface | grep -q $new_ip
if [ $? -ne 0 ]; then
ip addr show $iface
tst_resm TFAIL "$new_ip not configured"
return
fi
check_connectivity $cnt || return
cnt=$(($cnt + 1))
# Check the background TCP traffic
pgrep -x netstress > /dev/null || make_background_tcp_traffic
case $cmd_type in
if_cmd)
if [ "$TST_IPV6" ]; then
ifconfig $iface del $new_ip/$netmask
else
ifconfig $iface:1 down
fi
;;
ip_cmd) ip addr del $new_ip/$netmask dev $iface ;;
esac
if [ $? -ne 0 ]; then
tst_resm TFAIL " delete command failed".
return
fi
ip addr show $iface | grep -q $new_ip
if [ $? -eq 0 ]; then
ip addr show $iface
tst_resm TFAIL "Failed to remove '$new_ip' address"
return
fi
done
tst_resm TPASS "Test is finished correctly"
}
setup
tst_check_cmds ifconfig
test_body 'if_cmd'
test_body 'ip_cmd'
tst_exit